readi p,"Input prime p>3";

F:=GF(p);

Z:=Integers();
for i in [2..p-1] do
  a:=F!i;
  vals:={a^k:k in [1..p-1]};
  if #vals eq p-1 then w:=i; break; end if;
end for;

print "p,w equal",p,w;
k:=F!w;

V:=VectorSpace(F,3);
H:=Hom(V,V);

lead:=function(v)
  if v[1] ne 0 then return v[1]^-1*v; end if;
  if v[2] ne 0 then return v[2]^-1*v; end if;
  if v[3] ne 0 then return v[3]^-1*v; end if;
  return v;
end function;

orbreps:=[];

for x in [0,1] do
range:=[0..p-1];
if x eq 0 then range:=[0,1]; end if;
for y in range do
range:=[0..p-1];
if x eq 0 and y eq 0 then range:=[1]; end if;
for z in range do

  new:=true;
  v:=V![x,y,z];
  for a in F do
  for b in F do
    if a eq b or a eq -b then continue; end if;
    A:=H![a^2,2*a*b,b^2,k*a*b,a^2+k*b^2,a*b,k^2*b^2,2*k*a*b,a^2];
    A:=Transpose(A);
    u:=lead(v*A);
    x1:=Z!(u[1]); y1:=Z!(u[2]); z1:=Z!(u[3]);
    if [x1,y1,z1] lt [x,y,z] then new:=false; break; end if;
    A:=Transpose(A);
    A[1]:=-A[1];
    A[3]:=-A[3];
    A:=Transpose(A);
    u:=lead(v*A);
    x1:=Z!(u[1]); y1:=Z!(u[2]); z1:=Z!(u[3]);
    if [x1,y1,z1] lt [x,y,z] then new:=false; break; end if;
  end for;
  if not new then break; end if;
  end for;
  if new then Append(~orbreps,[x,y,z]); end if;

end for;
end for;
end for;

GS:=[];
//baaa=baab=0
for u in [0..p-1] do
  Append(~GS,
    Group<a,b,c,d|a^p,b^p,c^p,d^p,(c,a)=(b,a,b),(c,b)*(b,a,a)^w,(d,a),(d,b)=(b,a,b),(d,c)=(b,a,b,b)^u,(b,a,a,a),(b,a,a,b)>);
end for;
Append(~GS,
  Group<a,b,c,d|a^p,b^p,c^p,d^p,(c,a)=(b,a,b),(c,b)*(b,a,a)^w,(d,a)=(b,a,b,b),(d,b)=(b,a,b),(d,c),(b,a,a,a),(b,a,a,b)>);

//baab=babb+wbaaa=0
for u in [0..p-1] do
  Append(~GS,
    Group<a,b,c,d|a^p,b^p,c^p,d^p,(c,a)=(b,a,b),(c,b)*(b,a,a)^w,(d,a),(d,b)=(b,a,b),(d,c)=(b,a,a,a)^u,(b,a,a,b),(b,a,b,b)*(b,a,a,a)^w>);
end for;

//baaa=babb=0
for u in [0..(p-1) div 2] do
  Append(~GS,
    Group<a,b,c,d|a^p,b^p,c^p,d^p,(c,a)=(b,a,b),(c,b)*(b,a,a)^w,(d,a),(d,b)=(b,a,b),(d,c)=(b,a,a,b)^u,(b,a,a,a),(b,a,b,b)>);
end for;

//baab-vbaaa=babb-wbaaa=0 (v^2-w not a square)
for i in [0..p-1] do
  if not IsSquare(F!(i^2-w)) then v:=i; break; end if;
end for;
yous:=[0];
for i in [1..p-1] do
  if Z!(F!(2*w-i)) ge i then Append(~yous,i); end if;
end for;

for u in yous do
  Append(~GS,
    Group<a,b,c,d|a^p,b^p,c^p,d^p,(c,a)=(b,a,b),(c,b)*(b,a,a)^w,(d,a),(d,b)=(b,a,b),
                  (d,c)=(b,a,a,a)^u,(b,a,a,b)=(b,a,a,a)^v,(b,a,b,b)=(b,a,a,a)^w>);
end for;

//baab=babb-xbaaa=0 (x ne w, -x not a square)
for rep in orbreps do
  if rep[1] ne 1 then continue; end if;
  if rep[2] ne 0 then continue; end if;
  if rep[3] eq w then continue; end if;
  if rep[3] eq p-w then continue; end if;
  if IsSquare(F!(-rep[3])) then continue; end if;
  x:=rep[3];
  for u in [0..p-1] do
    Append(~GS,
      Group<a,b,c,d|a^p,b^p,c^p,d^p,(c,a)=(b,a,b),(c,b)*(b,a,a)^w,(d,a),(d,b)=(b,a,b),
      (d,c)=(b,a,a,a)^u,(b,a,a,b),(b,a,b,b)=(b,a,a,a)^x>);
  end for;
end for;

//baaa=babb-xbaab=0 (1 le x le (p-1)/2)
for x in [1..(p-1) div 2] do
for u in [0..p-1] do
    Append(~GS,
      Group<a,b,c,d|a^p,b^p,c^p,d^p,(c,a)=(b,a,b),(c,b)*(b,a,a)^w,(d,a),(d,b)=(b,a,b),
      (d,c)=(b,a,a,b)^u,(b,a,a,a),(b,a,b,b)=(b,a,a,b)^x>);
end for;
end for;

//baab-xbaaa=babb-ybaaa=0, x ne 0, y ne w, x^2-y not a square
for rep in orbreps do
  if rep[1] ne 1 then continue; end if;
  if rep[2] eq 0 then continue; end if;
  if rep[3] eq w then continue; end if;
  x:=rep[2]; y:=rep[3];
  if IsSquare(F!(x^2-y)) then continue; end if;
  for u in [0..p-1] do
    Append(~GS,
      Group<a,b,c,d|a^p,b^p,c^p,d^p,(c,a)=(b,a,b),(c,b)*(b,a,a)^w,(d,a),(d,b)=(b,a,b),
      (d,c)=(b,a,a,a)^u,(b,a,a,b)=(b,a,a,a)^x,(b,a,b,b)=(b,a,a,a)^y>);
  end for;
end for;

PS:=[];
for G in GS do
  P:=pQuotient(G,p,4);
  Append(~PS,P);
end for;

"Sequence PS contains",#PS,"groups of order p^8";

